#include <iostream>
#include <time.h>
#include <conio.h>
#include <malloc.h>
#include <emmintrin.h>
#include <smmintrin.h>
#include <xmmintrin.h>
#include <omp.h>
#include <immintrin.h>


using namespace std;
#include <amp.h>

using namespace concurrency;



accelerator pick_accelerator()
{
	vector<accelerator> accs = accelerator::get_all();
	accelerator chosen_one;
	auto result = std::find_if(accs.begin(), accs.end(), [](accelerator acc)
	{
		return !acc.is_emulated; });



	if (result != accs.end())
		chosen_one = *(result);
	std::wcout << chosen_one.description << std::endl;
	accelerator::set_default(chosen_one.device_path);
	return chosen_one;

}





void Autovec(float *Ax, float  *Ay, float * Az, float *Bx, float * By, float * Bz, float* Cx, float * Cy, float * Cz, float * Resx, float * Resy, float * Resz, const int N)
{

	float Res[3];
	float dis[3];
#pragma omp parallel for	
	for (int i = 0;i < N; ++i)

	{
		float A[3] = { Ax[i],Ay[i],Az[i] };
		float B[3] = { Bx[i],By[i],Bz[i] };
		float C[3] = { Cx[i],Cy[i],Cz[i] };

		for (int j = 0;j < 3;++j)
		{
			dis[j] = B[j] - A[j];
			Res[j] = A[j] + (C[j] - A[j])*dis[j] * dis[j] / (dis[j] * dis[j]);

		}

		Resx[i] = Res[0];
		Resy[i] = Res[1];
		Resz[i] = Res[2];




	}


}

void SSE_Singl(float *Ax, float  *Ay, float * Az, float *Bx, float * By, float * Bz, float* Cx, float * Cy, float * Cz, float * Resx, float * Resy, float * Resz, const int N)
{

	float* resultX = new float[4];
	float* resultY = new float[4];
	float* resultZ = new float[4];

	for (int i = 4;i < N;i = i + 4)

	{
		//_mm_set_ss
		//__m128 m1 = _mm_load_ps(f1);
		__declspec(align(16)) __m128 AxS = _mm_set_ps(Ax[i - 3], Ax[i - 2], Ax[i - 1], Ax[i]);
		__declspec(align(16)) __m128 BxS = _mm_set_ps(Bx[i - 3], Bx[i - 2], Bx[i - 1], Bx[i]);
		__declspec(align(16)) __m128 CxS = _mm_set_ps(Cx[i - 3], Cx[i - 2], Cx[i - 1], Cx[i]);

		__declspec(align(16)) __m128 AyS = _mm_set_ps(Ay[i - 3], Ay[i - 2], Ay[i - 1], Ay[i]);
		__declspec(align(16)) __m128 ByS = _mm_set_ps(By[i - 3], By[i - 2], By[i - 1], By[i]);
		__declspec(align(16)) __m128 CyS = _mm_set_ps(Cy[i - 3], Cy[i - 2], Cy[i - 1], Cy[i]);

		__declspec(align(16)) __m128 AzS = _mm_set_ps(Az[i - 3], Az[i - 2], Az[i - 1], Az[i]);
		__declspec(align(16)) __m128 BzS = _mm_set_ps(Bz[i - 3], Bz[i - 2], Bz[i - 1], Bz[i]);
		__declspec(align(16)) __m128 CzS = _mm_set_ps(Cz[i - 3], Cz[i - 2], Cz[i - 1], Cz[i]);



		//	Resx[i] = Ax[i] + (Cx[i] - Ax[i])*disx * disx / (disx * disx);


		__m128 DisX = _mm_sub_ps(BxS, AxS);
		__m128 DisY = _mm_sub_ps(ByS, AyS);
		__m128 DisZ = _mm_sub_ps(BzS, AzS);

		__m128 LaX = _mm_sub_ps(CxS, AxS);
		__m128 LaY = _mm_sub_ps(CyS, AyS);
		__m128 LaZ = _mm_sub_ps(CzS, AzS);

		__m128 L1x = _mm_mul_ps(LaX, DisX);
		__m128 L1y = _mm_mul_ps(LaY, DisY);
		__m128 L1z = _mm_mul_ps(LaZ, DisZ);

		L1x = _mm_mul_ps(L1x, DisX);
		L1y = _mm_mul_ps(L1y, DisY);
		L1z = _mm_mul_ps(L1y, DisY);

		__m128 disXst = _mm_mul_ps(DisX, DisX);
		__m128 disYst = _mm_mul_ps(DisY, DisY);
		__m128 disZst = _mm_mul_ps(DisY, DisY);

		L1x = _mm_div_ps(L1x, disXst);
		L1y = _mm_div_ps(L1y, disYst);
		L1z = _mm_div_ps(L1z, disZst);
		__m128 resX = _mm_add_ps(AxS, L1x);
		__m128 resY = _mm_add_ps(AyS, L1y);
		__m128 resZ = _mm_add_ps(AzS, L1z);

		_mm_store_ps((float*)resultX, resX);
		_mm_store_ps((float*)resultY, resY);
		_mm_store_ps((float*)resultZ, resZ);




		Resx[i - 3] = resultX[0];
		Resx[i - 2] = resultX[1];
		Resx[i - 1] = resultX[2];
		Resx[i] = resultX[3];

		Resy[i - 3] = resultY[0];
		Resy[i - 2] = resultY[1];
		Resy[i - 1] = resultY[2];
		Resy[i] = resultY[3];

		Resz[i - 3] = resultZ[0];
		Resz[i - 2] = resultZ[1];
		Resz[i - 1] = resultZ[2];
		Resz[i] = resultZ[3];







	}
};



	void SSE_Par(float *Ax, float  *Ay, float * Az, float *Bx, float * By, float * Bz, float* Cx, float * Cy, float * Cz, float * Resx, float * Resy, float * Resz, const int N)
	{


			float* resultX = new float[4];
			float* resultY = new float[4];
			float* resultZ = new float[4];


#pragma omp parallel for
			for (int i = 4;i < N;i = i + 4)

			{

				__declspec(align(16)) __m128 AxS = _mm_set_ps(Ax[i - 3], Ax[i - 2], Ax[i - 1], Ax[i]);
				__declspec(align(16)) __m128 BxS = _mm_set_ps(Bx[i - 3], Bx[i - 2], Bx[i - 1], Bx[i]);
				__declspec(align(16)) __m128 CxS = _mm_set_ps(Cx[i - 3], Cx[i - 2], Cx[i - 1], Cx[i]);

				__declspec(align(16)) __m128 AyS = _mm_set_ps(Ay[i - 3], Ay[i - 2], Ay[i - 1], Ay[i]);
				__declspec(align(16)) __m128 ByS = _mm_set_ps(By[i - 3], By[i - 2], By[i - 1], By[i]);
				__declspec(align(16)) __m128 CyS = _mm_set_ps(Cy[i - 3], Cy[i - 2], Cy[i - 1], Cy[i]);

				__declspec(align(16)) __m128 AzS = _mm_set_ps(Az[i - 3], Az[i - 2], Az[i - 1], Az[i]);
				__declspec(align(16)) __m128 BzS = _mm_set_ps(Bz[i - 3], Bz[i - 2], Bz[i - 1], Bz[i]);
				__declspec(align(16)) __m128 CzS = _mm_set_ps(Cz[i - 3], Cz[i - 2], Cz[i - 1], Cz[i]);



				__m128 DisX = _mm_sub_ps(BxS, AxS);
				__m128 DisY = _mm_sub_ps(ByS, AyS);
				__m128 DisZ = _mm_sub_ps(BzS, AzS);

				__m128 LaX = _mm_sub_ps(CxS, AxS);
				__m128 LaY = _mm_sub_ps(CyS, AyS);
				__m128 LaZ = _mm_sub_ps(CzS, AzS);

				__m128 L1x = _mm_mul_ps(LaX, DisX);
				__m128 L1y = _mm_mul_ps(LaY, DisY);
				__m128 L1z = _mm_mul_ps(LaZ, DisZ);

				L1x = _mm_mul_ps(L1x, DisX);
				L1y = _mm_mul_ps(L1y, DisY);
				L1z = _mm_mul_ps(L1y, DisY);

				__m128 disXst = _mm_mul_ps(DisX, DisX);
				__m128 disYst = _mm_mul_ps(DisY, DisY);
				__m128 disZst = _mm_mul_ps(DisY, DisY);

				L1x = _mm_div_ps(L1x, disXst);
				L1y = _mm_div_ps(L1y, disYst);
				L1z = _mm_div_ps(L1z, disZst);
				__m128 resX = _mm_add_ps(AxS, L1x);
				__m128 resY = _mm_add_ps(AyS, L1y);
				__m128 resZ = _mm_add_ps(AzS, L1z);

				_mm_store_ps((float*)resultX, resX);
				_mm_store_ps((float*)resultY, resY);
				_mm_store_ps((float*)resultZ, resZ);




				Resx[i - 3] = resultX[0];
				Resx[i - 2] = resultX[1];
				Resx[i - 1] = resultX[2];
				Resx[i] = resultX[3];

				Resy[i - 3] = resultY[0];
				Resy[i - 2] = resultY[1];
				Resy[i - 1] = resultY[2];
				Resy[i] = resultY[3];

				Resz[i - 3] = resultZ[0];
				Resz[i - 2] = resultZ[1];
				Resz[i - 1] = resultZ[2];
				Resz[i] = resultZ[3];







			}
	};

		 




void rando(float * nums, const int N)
{


	for (int i = 0;i < N;i++)
	{
		float  num = 0.3* (rand() % 200 + 1);
		nums[i] = num;
	}




}

void standM(float *Ax, float  *Ay, float * Az, float *Bx, float * By, float * Bz, float* Cx, float * Cy, float * Cz, float * Resx, float * Resy, float * Resz, const int N)
{




	for (int i = 0;i < N;++i)

	{

		float disx = Bx[i] - Ax[i];
		float disy = By[i] - Ay[i];
		float disz = Bz[i] - Az[i];



		Resx[i] = Ax[i] + (Cx[i] - Ax[i])*disx * disx / (disx * disx);
		Resy[i] = Ay[i] + (Cy[i] - Ay[i])*disy * disy / (disy * disy);
		Resz[i] = Az[i] + (Cz[i] - Az[i])*disz * disz / (disz * disz);

	}

}


void AMP(float *Ax, float  *Ay, float * Az, float *Bx, float * By, float * Bz, float* Cx, float * Cy, float * Cz, float * Resx, float * Resy, float * Resz, const int N, double &Tim, double &Tim2)

{
	double t1 = clock();
	float * disx = new float[N];
	float * disy = new float[N];
	float * disz = new float[N];



	array_view<float, 1>disxd(N, disx);
	array_view<float, 1>disyd(N, disy);
	array_view<float, 1>diszd(N, disz);

	array_view<float, 1> Axd(N, Ax);
	array_view<float, 1> Ayd(N, Ay);
	array_view<float, 1> Azd(N, Az);

	array_view<float, 1> Bxd(N, Bx);
	array_view<float, 1> Byd(N, By);
	array_view<float, 1> Bzd(N, Bz);

	array_view<float, 1> Cxd(N, Cx);
	array_view<float, 1> Cyd(N, Cy);
	array_view<float, 1> Czd(N, Cz);

	array_view<float, 1> Resxd(N, Resx);
	array_view<float, 1> Resyd(N, Resy);
	array_view<float, 1> Reszd(N, Resz);
	Resxd.discard_data();
	Resyd.discard_data();
	Reszd.discard_data();

	double t2 = clock() - t1;
	Tim = t2 / CLOCKS_PER_SEC;

	t1 = clock();

	parallel_for_each(Resxd.extent, [=](index<1> idx) restrict(amp)
	{
		disxd[idx] = Bxd[idx] - Axd[idx];



		Resxd[idx] = Axd[idx] + (Cxd[idx] - Axd[idx])*disxd[idx] * disxd[idx] / (disxd[idx] * disxd[idx]);



	});

	Resxd.synchronize();

	parallel_for_each(Resyd.extent, [=](index<1> idx) restrict(amp)
	{
		disyd[idx] = Byd[idx] - Ayd[idx];
		Resyd[idx] = Ayd[idx] + (Cyd[idx] - Ayd[idx])*disyd[idx] * disyd[idx] / (disyd[idx] * disyd[idx]);


		//Resyd[idx] = Ayd[idx] + (Cyd[idx] - Ayd[idx])*(Byd[idx] - Ayd[idx]) * (Byd[idx] - Ayd[idx]) / ((Byd[idx] - Ayd[idx]) * (Byd[idx] - Ayd[idx]));


	});

	Resyd.synchronize();

	parallel_for_each(Reszd.extent, [=](index<1> idx) restrict(amp)
	{

		diszd[idx] = (Bzd[idx] - Azd[idx]);
		Reszd[idx] = Azd[idx] + (Czd[idx] - Azd[idx])*diszd[idx] * diszd[idx] / (diszd[idx] * diszd[idx]);
	});


	Reszd.synchronize();

	t2 = clock() - t1;
	Tim2 = t2 / CLOCKS_PER_SEC;

};



void standMPar(float *Ax, float  *Ay, float * Az, float *Bx, float * By, float * Bz, float* Cx, float * Cy, float * Cz, float * Resx, float * Resy, float * Resz, const int N)
{


#pragma omp parallel for
	for (int i = 0;i < N;++i)

	{

		float disx = Bx[i] - Ax[i];
		float disy = By[i] - Ay[i];
		float disz = Bz[i] - Az[i];



		Resx[i] = Ax[i] + (Cx[i] - Ax[i])*disx * disx / (disx * disx);
		Resy[i] = Ay[i] + (Cy[i] - Ay[i])*disy * disy / (disy * disy);
		Resz[i] = Az[i] + (Cz[i] - Az[i])*disz * disz / (disz * disz);

	}






}


int main()
{
	setlocale(LC_ALL, "Russian");

	long int N = 2097152;


	float * Ax = new float[N];
	float * Ay = new float[N];
	float * Az = new float[N];

	float * Bx = new float[N];
	float * By = new float[N];
	float * Bz = new float[N];

	float * Cx = new float[N];
	float * Cy = new float[N];
	float * Cz = new float[N];

	float * Resx = new float[N];
	float * Resy = new float[N];
	float * Resz = new float[N];

	//srand(time(NULL));

	rando(Ax, N);
	rando(Ay, N);
	rando(Az, N);

	rando(Bx, N);
	rando(By, N);
	rando(Bz, N);

	rando(Cx, N);
	rando(Cy, N);
	rando(Cz, N);


	double t1 = clock();
	standM(Ax, Ay, Az, Bx, By, Bz, Cx, Cy, Cz, Resx, Resy, Resz, N);
	double t2 = clock() - t1;
	double tres = t2 / CLOCKS_PER_SEC;



	cout << " --- -- : " << N << endl;


	cout << "________________________ _______________________________________" << endl;
	cout << "x = " << Resx[1356] << " :  y = " << Resy[1356] << " :z = " << Resz[1356] << " " << endl;
	cout << "*******************************************************************" << endl;

	cout << "   " << endl;
	cout << " --- -- : " << tres << "" << endl;
	cout << "________________________________________________________________________________" << endl;
	cout << endl;




	t1 = clock();
	standMPar(Ax, Ay, Az, Bx, By, Bz, Cx, Cy, Cz, Resx, Resy, Resz, N);
	t2 = clock() - t1;
	tres = t2 / CLOCKS_PER_SEC;

	cout << "________________________ _______________________________________" << endl;
	cout << "x = " << Resx[1356] << " :  y = " << Resy[1356] << " :z = " << Resz[1356] << " " << endl;
	cout << "*******************************************************************" << endl;

	cout << "   " << endl;
	cout << " --- -- : " << tres << "" << endl;
	cout << "________________________________________________________________________________" << endl;

	cout << endl;

	t1 = clock();
	Autovec(Ax, Ay, Az, Bx, By, Bz, Cx, Cy, Cz, Resx, Resy, Resz, N);
	t2 = clock() - t1;
	tres = t2 / CLOCKS_PER_SEC;

	/* cout << "________________________ _______________________________________" << endl;
	cout << "x = " << Resx[1356] << " :  y = " << Resy[1356] << " :z = " << Resz[1356] << " " << endl;
	cout << "*******************************************************************" << endl;

	cout << " loop" << endl;
	cout << " --- -- : " << tres << "" << endl;
	cout << "________________________________________________________________________________" << endl;

	cout << endl; */






	t1 = clock();
	SSE_Par(Ax, Ay, Az, Bx, By, Bz, Cx, Cy, Cz, Resx, Resy, Resz, N);

	t2 = clock() - t1;
	tres = t2 / CLOCKS_PER_SEC;

	cout << "________________________ _______________________________________" << endl;
	cout << "x = " << Resx[1356] << " :  y = " << Resy[1356] << " :z = " << Resz[1356] << " " << endl;
	cout << "*******************************************************************" << endl;

	cout << "SSE  " << endl;
	cout << " --- -- : " << tres << "" << endl;
	cout << "________________________________________________________________________________" << endl;

	cout << endl;


	t1 = clock();
	SSE_Singl(Ax, Ay, Az, Bx, By, Bz, Cx, Cy, Cz, Resx, Resy, Resz, N);

	t2 = clock() - t1;
	tres = t2 / CLOCKS_PER_SEC;

	cout << "________________________ _______________________________________" << endl;
	cout << "x = " << Resx[1356] << " :  y = " << Resy[1356] << " :z = " << Resz[1356] << " " << endl;
	cout << "*******************************************************************" << endl;

	cout << "SSE  " << endl;
	cout << " --- -- : " << tres << "" << endl;
	cout << "________________________________________________________________________________" << endl;

	cout << endl;


	double Tim;
	double Tim2;

	cout << ":" << endl;
	pick_accelerator();
	cout << "___________________________________________" << endl;

	t1 = clock();

	AMP(Ax, Ay, Az, Bx, By, Bz, Cx, Cy, Cz, Resx, Resy, Resz, N, Tim, Tim2);
	t2 = clock() - t1;
	tres = t2 / CLOCKS_PER_SEC;


	cout << "________________________ _______________________________________" << endl;
	cout << "x = " << Resx[1356] << " :  y = " << Resy[1356] << " :z = " << Resz[1356] << " " << endl;

	cout << "*******************************************************************" << endl;

	cout << "AMP  " << endl;
	cout << " --- -- : " << tres << "" << endl;
	cout << "________________________________________________________________________________" << endl;
	cout << "     " << Tim << "" << endl;
	cout << "   " << Tim2 << "" << endl;


	delete[]Ax;
	delete[]Ay;
	delete[]Az;

	delete[]Bx;
	delete[]By;
	delete[]Bz;

	delete[]Cx;
	delete[]Cy;
	delete[]Cz;





	system("pause");
}
